Index: trunk/LMDZ.COMMON/libf/evolution/compute_tend_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/compute_tend_mod.F90	(revision 3149)
+++ trunk/LMDZ.COMMON/libf/evolution/compute_tend_mod.F90	(revision 3149)
@@ -0,0 +1,37 @@
+MODULE compute_tend_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE compute_tend(ngrid,nslope,min_ice,tendencies_ice)
+
+implicit none
+
+!=======================================================================
+!
+! Compute the tendencies of the evolution of water ice over the years
+!
+!=======================================================================
+
+!   arguments:
+!   ----------
+!   INPUT
+integer,                         intent(in) :: ngrid   ! # of grid points
+integer,                         intent(in) :: nslope  ! # of subslopes
+real, dimension(ngrid,nslope,2), intent(in) :: min_ice ! Minima of ice at each point for the PCM years
+
+!   OUTPUT
+real, dimension(ngrid,nslope), intent(out) :: tendencies_ice ! Difference between the minima = evolution of perennial ice
+!=======================================================================
+! We compute the difference
+tendencies_ice = min_ice(:,:,2) - min_ice(:,:,1)
+
+! If the difference is too small, then there is no evolution
+where (abs(tendencies_ice) < 1.e-10) tendencies_ice = 0.
+
+END SUBROUTINE compute_tend
+
+END MODULE compute_tend_mod
Index: trunk/LMDZ.COMMON/libf/evolution/comsoil_h_PEM.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/comsoil_h_PEM.F90	(revision 3145)
+++ trunk/LMDZ.COMMON/libf/evolution/comsoil_h_PEM.F90	(revision 3149)
@@ -3,27 +3,26 @@
 implicit none
 
-integer, parameter                        :: nsoilmx_PEM = 68    ! number of layers in the PEM
-real, allocatable, dimension(:),     save :: layer_PEM           ! soil layer depths [m]
-real, allocatable, dimension(:),     save :: mlayer_PEM          ! soil mid-layer depths [m]
-real, allocatable, dimension(:,:,:), save :: TI_PEM              ! soil thermal inertia [SI]
-real, allocatable, dimension(:,:),   save :: inertiedat_PEM      ! soil thermal inertia saved as reference for current climate [SI]
+integer, parameter                        :: nsoilmx_PEM = 68     ! number of layers in the PEM
+real, allocatable, dimension(:),     save :: layer_PEM            ! soil layer depths [m]
+real, allocatable, dimension(:),     save :: mlayer_PEM           ! soil mid-layer depths [m]
+real, allocatable, dimension(:,:,:), save :: TI_PEM               ! soil thermal inertia [SI]
+real, allocatable, dimension(:,:),   save :: inertiedat_PEM       ! soil thermal inertia saved as reference for current climate [SI]
 ! Variables (FC: built in firstcall in soil.F)
-real, allocatable, dimension(:,:,:), save :: tsoil_PEM           ! sub-surface temperatures [K]
-real, allocatable, dimension(:,:),   save :: mthermdiff_PEM      ! (FC) mid-layer thermal diffusivity [SI]
-real, allocatable, dimension(:,:),   save :: thermdiff_PEM       ! (FC) inter-layer thermal diffusivity [SI]
-real, allocatable, dimension(:),     save :: coefq_PEM           ! (FC) q_{k+1/2} coefficients [SI]
-real, allocatable, dimension(:,:),   save :: coefd_PEM           ! (FC) d_k coefficients [SI]
-real, allocatable, dimension(:,:),   save :: alph_PEM            ! (FC) alpha_k coefficients [SI]
-real, allocatable, dimension(:,:),   save :: beta_PEM            ! beta_k coefficients [SI]
-real,                                save :: mu_PEM              ! mu coefficient [SI]
-real,                                save :: fluxgeo             ! Geothermal flux [W/m^2]
-real,                                save :: depth_breccia       ! Depth at which we have breccia [m]
-real,                                save :: depth_bedrock       ! Depth at which we have bedrock [m]
-integer,                             save :: index_breccia       ! last index of the depth grid before having breccia
-integer,                             save :: index_bedrock       ! last index of the depth grid before having bedrock
-logical                                   :: soil_pem            ! True by default, to run with the subsurface physic. Read in pem.def
-real, allocatable, dimension(:),     save :: water_reservoir     ! Large reserve of water [kg/m^2]
-real,                                save :: water_reservoir_nom ! Nominal value for the large reserve of water [kg/m^2]
-logical,                             save :: reg_thprop_dependp  ! thermal properites of the regolith vary with the surface pressure
+real, allocatable, dimension(:,:,:), save :: tsoil_PEM            ! sub-surface temperatures [K]
+real, allocatable, dimension(:,:),   save :: mthermdiff_PEM       ! (FC) mid-layer thermal diffusivity [SI]
+real, allocatable, dimension(:,:),   save :: thermdiff_PEM        ! (FC) inter-layer thermal diffusivity [SI]
+real, allocatable, dimension(:),     save :: coefq_PEM            ! (FC) q_{k+1/2} coefficients [SI]
+real, allocatable, dimension(:,:),   save :: coefd_PEM            ! (FC) d_k coefficients [SI]
+real, allocatable, dimension(:,:),   save :: alph_PEM             ! (FC) alpha_k coefficients [SI]
+real, allocatable, dimension(:,:),   save :: beta_PEM             ! beta_k coefficients [SI]
+real,                                save :: mu_PEM               ! mu coefficient [SI]
+real,                                save :: fluxgeo              ! Geothermal flux [W/m^2]
+real,                                save :: depth_breccia        ! Depth at which we have breccia [m]
+real,                                save :: depth_bedrock        ! Depth at which we have bedrock [m]
+integer,                             save :: index_breccia        ! last index of the depth grid before having breccia
+integer,                             save :: index_bedrock        ! last index of the depth grid before having bedrock
+logical                                   :: soil_pem             ! True by default, to run with the subsurface physic. Read in pem.def
+real,                                save :: ini_h2o_bigreservoir ! Initial value for the large reservoir of water [kg/m^2]
+logical,                             save :: reg_thprop_dependp   ! thermal properites of the regolith vary with the surface pressure
 
 !=======================================================================
@@ -39,15 +38,14 @@
 
 allocate(layer_PEM(nsoilmx_PEM))
-allocate(mlayer_PEM(0:nsoilmx_PEM-1))
+allocate(mlayer_PEM(0:nsoilmx_PEM - 1))
 allocate(TI_PEM(ngrid,nsoilmx_PEM,nslope))
 allocate(tsoil_PEM(ngrid,nsoilmx_PEM,nslope))
-allocate(mthermdiff_PEM(ngrid,0:nsoilmx_PEM-1))
-allocate(thermdiff_PEM(ngrid,nsoilmx_PEM-1))
-allocate(coefq_PEM(0:nsoilmx_PEM-1))
-allocate(coefd_PEM(ngrid,nsoilmx_PEM-1))
-allocate(alph_PEM(ngrid,nsoilmx_PEM-1))
-allocate(beta_PEM(ngrid,nsoilmx_PEM-1))
+allocate(mthermdiff_PEM(ngrid,0:nsoilmx_PEM - 1))
+allocate(thermdiff_PEM(ngrid,nsoilmx_PEM - 1))
+allocate(coefq_PEM(0:nsoilmx_PEM - 1))
+allocate(coefd_PEM(ngrid,nsoilmx_PEM - 1))
+allocate(alph_PEM(ngrid,nsoilmx_PEM - 1))
+allocate(beta_PEM(ngrid,nsoilmx_PEM - 1))
 allocate(inertiedat_PEM(ngrid,nsoilmx_PEM))
-allocate(water_reservoir(ngrid))
 
 END SUBROUTINE ini_comsoil_h_PEM
@@ -70,5 +68,4 @@
 if (allocated(beta_PEM)) deallocate(beta_PEM)
 if (allocated(inertiedat_PEM)) deallocate(inertiedat_PEM)
-if (allocated(water_reservoir)) deallocate(water_reservoir)
 
 END SUBROUTINE end_comsoil_h_PEM
Index: trunk/LMDZ.COMMON/libf/evolution/conf_pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/conf_pem.F90	(revision 3145)
+++ trunk/LMDZ.COMMON/libf/evolution/conf_pem.F90	(revision 3149)
@@ -25,7 +25,7 @@
 use time_evol_mod,    only: year_bp_ini, dt_pem, water_ice_criterion, co2_ice_criterion, ps_criterion, Max_iter_pem, &
                           evol_orbit_pem, var_obl, var_ecc, var_lsp, convert_years
-use comsoil_h_pem,    only: soil_pem, fluxgeo, water_reservoir_nom, depth_breccia, depth_bedrock, reg_thprop_dependp
+use comsoil_h_pem,    only: soil_pem, fluxgeo, ini_h2o_bigreservoir, depth_breccia, depth_bedrock, reg_thprop_dependp
 use adsorption_mod,   only: adsorption_pem
-use glaciers_mod,     only: co2glaciersflow, h2oglaciersflow
+use glaciers_mod,     only: co2_ice_flow, h2o_ice_flow
 use ice_table_mod,    only: icetable_equilibrium, icetable_dynamic
 use time_phylmdz_mod, only: ecritphy
@@ -71,5 +71,5 @@
 var_ecc = .true.
 call getin('var_ecc',var_ecc)
-write(*,*) 'Does excentricity vary ?',var_ecc
+write(*,*) 'Does eccentricity vary ?',var_ecc
 
 var_lsp = .true.
@@ -100,9 +100,9 @@
 call getin('adsorption_pem',adsorption_pem)
 
-co2glaciersflow = .true.
-call getin('co2glaciersflow',co2glaciersflow)
+co2_ice_flow = .true.
+call getin('co2_ice_flow',co2_ice_flow)
 
-h2oglaciersflow = .true.
-call getin('h2oglaciersflow',h2oglaciersflow)
+h2o_ice_flow = .true.
+call getin('h2o_ice_flow',h2o_ice_flow)
 
 reg_thprop_dependp = .false.
@@ -156,6 +156,6 @@
 endif
 
-water_reservoir_nom = 1.e4
-call getin('water_reservoir_nom',water_reservoir_nom)
+ini_h2o_bigreservoir = 1.e4
+call getin('ini_h2o_bigreservoir',ini_h2o_bigreservoir)
 
 END SUBROUTINE conf_pem
Index: trunk/LMDZ.COMMON/libf/evolution/constants_marspem_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/constants_marspem_mod.F90	(revision 3145)
+++ trunk/LMDZ.COMMON/libf/evolution/constants_marspem_mod.F90	(revision 3149)
@@ -12,32 +12,31 @@
 real, parameter :: m_h2o = 18.01528e-3 ! Molecular weight of h2o (kg/mol)
 
-!     Coefficient for Clapeyron law for CO2 condensation temperature (Tco2 = beta/(alpha-log(vmr)),following James et al. 1992
+! Coefficient for Clapeyron law for CO2 condensation temperature (Tco2 = beta/(alpha-log(vmr)),following James et al. 1992
 real, parameter :: alpha_clap_co2 = 23.3494 ! Uniteless, James et al. 1992
 real, parameter :: beta_clap_co2 = 3182.48  ! Kelvin, James et al. 1992
 
-!     Coefficient for Clapeyron law for psat (psat = exp(beta/Th2o+alpha)),following Murphy and Koop 2005
+! Coefficient for Clapeyron law for psat (psat = exp(beta/Th2o+alpha)),following Murphy and Koop 2005
 real, parameter :: alpha_clap_h2o = 28.9074 ! Uniteless, Murphy and Koop 2005
 real, parameter :: beta_clap_h2o = -6143.7  ! Kelvin, Murphy and Koop 2005
 
-!     Density of the regolith (Zent et al., 1995, Buhler and Piqueux 2021)     
+! Density of the regolith (Zent et al., 1995, Buhler and Piqueux 2021)     
 real, parameter :: rho_regolith = 2000. ! kg/m^3
 
-!     Average  Thermal inertia of the surface, breccia, bedrock, following Mellon et al., 2000., Wood et al., 2008
+! Average thermal inertia of the surface, breccia, bedrock, following Mellon et al., 2000., Wood et al., 2008
 real, parameter :: TI_regolith_avg = 250. ! Averaged of the observed thermal inertia for regolith following Mellon et al., 2000[SI]
 real, parameter :: TI_breccia = 750.      ! Thermal inertia of Breccia following Wood 2009 [SI]
 real, parameter :: TI_bedrock = 2300.     ! Thermal inertia of Bedrock following Wood 2009 [SI]
 
-!     Porosity of the soil
+! Porosity of the soil
 real, parameter :: porosity = 0.4 ! porosity of the martian soil, correspond to the value for a random loose packing of monodiperse sphere (Scott, 1960)
 
-!     Stefan Boltzmann constant
+! Stefan Boltzmann constant
 real, parameter :: sigmaB = 5.678e-8 
 
-!     Latent heat of CO2
+! Latent heat of CO2
 real, parameter :: Lco2 =  5.71e5 ! Pilorget and Forget 2016
 
-! Conversion H2O/CO2 frost to perennial frost and vice versa
-real, parameter :: threshold_h2o_frost2perennial = 1000.  !~ 1 m
-real, parameter :: threshold_co2_frost2perennial = 16000. !~ 10 m
+! Threshold to consider the amount of H2O ice as an infinite reservoir
+real, parameter :: inf_h2oice_threshold = 2000.  !~ 1 m
 
 END MODULE constants_marspem_mod
Index: trunk/LMDZ.COMMON/libf/evolution/evol_ice_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/evol_ice_mod.F90	(revision 3149)
+++ trunk/LMDZ.COMMON/libf/evolution/evol_ice_mod.F90	(revision 3149)
@@ -0,0 +1,160 @@
+MODULE evol_ice_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE evol_co2_ice(ngrid,nslope,co2_ice,tend_co2_ice)
+
+use time_evol_mod, only: dt_pem
+
+implicit none
+
+!=======================================================================
+!
+! Routine to compute the evolution of CO2 ice
+!
+!=======================================================================
+!   arguments:
+!   ----------
+!   INPUT
+integer, intent(in) :: ngrid, nslope ! # of grid points, # of subslopes
+
+!   OUTPUT
+real, dimension(ngrid,nslope), intent(inout) :: co2_ice      ! Previous and actual density of CO2 ice
+real, dimension(ngrid,nslope), intent(inout) :: tend_co2_ice ! Evolution of perennial ice over one year
+
+!   local:
+!   ----
+
+!=======================================================================
+! Evolution of CO2 ice for each physical point
+write(*,*) 'Evolution of co2 ice'
+co2_ice = co2_ice + tend_co2_ice*dt_pem
+where (co2_ice < 0.)
+    co2_ice = 0.
+    tend_co2_ice = 0.
+end where
+
+END SUBROUTINE evol_co2_ice
+
+!=======================================================================
+
+SUBROUTINE evol_h2o_ice(ngrid,nslope,cell_area,delta_h2o_adsorbded,delta_h2o_icetablesublim,h2o_ice,tend_h2o_ice,stopPEM)
+
+use time_evol_mod,          only: dt_pem
+use comslope_mod,           only: subslope_dist, def_slope_mean
+use criterion_pem_stop_mod, only: criterion_waterice_stop
+
+#ifndef CPP_STD
+    use comcstfi_h,   only: pi
+#else
+    use comcstfi_mod, only: pi
+#endif
+
+implicit none
+
+!=======================================================================
+!
+! Routine that compute the evolution of the h2o ice
+!
+!=======================================================================
+!   arguments:
+!   ----------
+!   INPUT
+integer,                intent(in) :: ngrid, nslope            ! # of grid points, # of subslopes
+real, dimension(ngrid), intent(in) :: cell_area                ! Area of each mesh grid (m^2)
+real, dimension(ngrid), intent(in) :: delta_h2o_adsorbded      ! Mass of H2O adsorbded/desorbded in the soil (kg/m^2)
+real, dimension(ngrid), intent(in) :: delta_h2o_icetablesublim ! Mass of H2O that have condensed/sublimated at the ice table (kg/m^2)
+
+!   OUTPUT
+real, dimension(ngrid,nslope), intent(inout) :: h2o_ice      ! Previous and actual density of h2o ice (kg/m^2)
+real, dimension(ngrid,nslope), intent(inout) :: tend_h2o_ice ! Evolution of perennial ice over one year (kg/m^2/year)
+integer,                       intent(inout) :: stopPEM      ! Stopping criterion code
+
+!   local:
+!   ------
+integer                       :: i, j, islope                                        ! Loop variables
+real                          :: pos_tend, neg_tend, real_coefficient, negative_part ! Variable to conserve h2o
+real, dimension(ngrid,nslope) :: new_tendencies                                      ! Tendencies computed in order to conserve h2o ice on the surface, only exchange between surface are done
+!=======================================================================
+if (ngrid /= 1) then ! Not in 1D
+    ! We compute the amount of condensing and sublimating h2o ice
+    pos_tend = 0.
+    neg_tend = 0.
+    do i = 1,ngrid
+        if (delta_h2o_adsorbded(i) > 0.) then
+            pos_tend = pos_tend + delta_h2o_adsorbded(i)*cell_area(i)
+        else
+            neg_tend = neg_tend + delta_h2o_adsorbded(i)*cell_area(i)
+        endif
+        if (delta_h2o_icetablesublim(i) > 0.) then
+            pos_tend = pos_tend + delta_h2o_icetablesublim(i)*cell_area(i)
+        else
+            neg_tend = neg_tend + delta_h2o_icetablesublim(i)*cell_area(i)
+        endif
+        do islope = 1,nslope
+            if (h2o_ice(i,islope) > 0.) then
+                if (tend_h2o_ice(i,islope) > 0.) then
+                    pos_tend = pos_tend + tend_h2o_ice(i,islope)*cell_area(i)*subslope_dist(i,islope)/cos(def_slope_mean(islope)*pi/180.)
+                else
+                    neg_tend = neg_tend - tend_h2o_ice(i,islope)*cell_area(i)*subslope_dist(i,islope)/cos(def_slope_mean(islope)*pi/180.)
+                endif
+            endif
+        enddo
+    enddo
+    ! We adapt the tendencies to conserve h2o and do only exchange between grid points
+    if (neg_tend > pos_tend .and. pos_tend > 0.) then ! More sublimation on the planet than condensation
+        where (tend_h2o_ice < 0.) ! We lower the sublimating rate by a coefficient
+            new_tendencies = tend_h2o_ice*pos_tend/neg_tend
+        elsewhere ! We don't change the condensing rate
+            new_tendencies = tend_h2o_ice
+        end where
+    else if (neg_tend < pos_tend .and. neg_tend > 0.) then ! More condensation on the planet than sublimation
+        where (tend_h2o_ice < 0.) ! We don't change the sublimating rate
+            new_tendencies = tend_h2o_ice
+        elsewhere ! We lower the condensing rate by a coefficient
+            new_tendencies = tend_h2o_ice*neg_tend/pos_tend
+        end where
+    else if (abs(pos_tend) < 1.e-10 .or. abs(neg_tend) == 1.e-10) then
+        write(*,*) "Reason of stopping: there is no sublimating or condensing h20 ice!"
+        write(*,*) "Tendencies on ice sublimating =", neg_tend
+        write(*,*) "Tendencies on ice increasing =", pos_tend
+        write(*,*) "This can be due to the absence of h2o ice in the PCM run!"
+        stopPEM = 2
+        new_tendencies = 0.
+    endif
+
+    ! Evolution of the h2o ice for each physical point
+    h2o_ice = h2o_ice + new_tendencies*dt_pem
+
+    ! We compute the amount of h2o that is sublimated in excess
+    negative_part = 0.
+    do i = 1,ngrid
+        do islope = 1,nslope
+            if (h2o_ice(i,islope) < 0.) then
+                negative_part = negative_part - h2o_ice(i,islope)*cell_area(i)*subslope_dist(i,islope)/cos(def_slope_mean(islope)*pi/180.)
+                h2o_ice(i,islope) = 0.
+                tend_h2o_ice(i,islope) = 0.
+            endif
+        enddo
+    enddo
+
+    ! We compute a coefficient by which we should remove the ice that has been added to places
+    ! even if this ice was contributing to an unphysical negative amount of ice at other places
+    if (abs(pos_tend) < 1.e-10) then
+        real_coefficient = 0.
+    else
+        real_coefficient = negative_part/pos_tend
+    endif
+    ! In the place of accumulation of ice, we remove a bit of ice in order to conserve h2o
+    where (new_tendencies > 0.) h2o_ice = h2o_ice - new_tendencies*real_coefficient*dt_pem*cos(def_slope_mean(islope)*pi/180.)
+else ! ngrid == 1, i.e. in 1D
+    h2o_ice = h2o_ice + tend_h2o_ice*dt_pem
+endif
+
+END SUBROUTINE evol_h2o_ice
+
+END MODULE evol_ice_mod
